#!/bin/sh

# Generate a source drop for an PyDev

# Usage message
usage="usage: $0 <project_name> <cvs_root> <cvs_tag> <cvs_directory>"

project_name=$1
cvs_root=$2
cvs_tag=$3
cvs_directory=$4

# Ensure we got all of the variables
if [ "x$project_name"x = "xx" ]
then
        echo >&2 "$usage"
        exit 1
fi

if [ "x$cvs_root"x = "xx" ]
then
        echo >&2 "$usage"
        exit 1
fi

if [ "x$cvs_tag"x = "xx" ]
then
        echo >&2 "$usage"
        exit 1
fi

if [ "x$cvs_directory"x = "xx" ]
then
        echo >&2 "$usage"
        exit 1
fi

mkdir -p temp/home && cd temp
#cvs -d $cvs_root co -r $cvs_tag $cvs_directory
cvs -d $cvs_root co $cvs_directory

pushd pydev
# This patch adds the new plugins to the map file
patch -p0 << _EOF_

Index: org.python.pydev.releng/maps/pydev.map
===================================================================
RCS file: /cvs/eclipse/pydev/org.python.pydev.releng/maps/pydev.map,v
retrieving revision 1.1
diff -u -p -r1.1 pydev.map
--- org.python.pydev.releng/maps/pydev.map	7 Mar 2005 17:38:25 -0000	1.1
+++ org.python.pydev.releng/maps/pydev.map	12 Jan 2007 20:40:45 -0000
@@ -1,4 +1,10 @@
 plugin@org.python.pydev=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
 plugin@org.python.pydev.debug=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
 plugin@org.python.pydev.help=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.templates=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.jython=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.ast=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.parser=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.core=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
+plugin@org.python.pydev.refactoring=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,
 feature@org.python.pydev.feature=HEAD,:pserver:anonymous@cvs.sourceforge.net:/cvsroot/pydev,,

_EOF_

popd

pushd $cvs_directory

# Fix the map file
sed --in-place "s/HEAD/$cvs_tag/g" maps/pydev.map
sed --in-place "s|cvs.sourceforge.net|pydev.cvs.sourceforge.net|g" maps/pydev.map

# Fetch the actual source

eclipse \
  -nosplash \
  -Duser.home=../../home \
  -application \
  org.eclipse.ant.core.antRunner \
  -buildfile build.xml \
  -DbaseLocation=/usr/share/eclipse \
  -Dpde.build.scripts=/usr/share/eclipse/plugins/org.eclipse.pde.build/scripts \
  -Dcomponent=sdk \
  -DbaseExists=true \
  -DmapCvsRoot="$cvs_root" \
  fetch
  
popd
# Make the source tarball
tar jcf eclipse-$project_name-fetched-src-$cvs_tag.tar.bz2 $cvs_directory
